DECLARE SUB vsintro ()
DECLARE SUB ripple ()
DECLARE SUB drawobject ()
DECLARE SUB rotate ()
DECLARE SUB initobject ()
'$INCLUDE: 'dash.bi'
TYPE coord3d
   x AS INTEGER
   y AS INTEGER
   z AS INTEGER
END TYPE
TYPE coord2d
   x AS INTEGER
   y AS INTEGER
END TYPE
DIM SHARED object(120, 3) AS coord3d, coordbuffer(120) AS coord3d
DIM SHARED obr AS INTEGER, obr2 AS INTEGER, radius AS INTEGER
DIM SHARED max AS INTEGER, buffer%(31999), box%(801), box2%(15241)
DIM SHARED pt2d(120) AS coord2d, t2%, choppy%, y2%, box3%(1801)
vsintro

REM $DYNAMIC
SUB drawobject
  
   VSFill VARSEG(buffer%(0)), VARPTR(buffer%(0)), 0
   FOR obr = 12 TO 108
      pt2d(obr).x = radius * 10& * object(obr, 0).x \ (coordbuffer(obr).z + radius * 16) + 160
      pt2d(obr).y = radius * 10& * coordbuffer(obr).y \ (coordbuffer(obr).z + radius * 16) + 90 + y2%
   NEXT
  
   FOR obry% = 8 TO 1 STEP -1
      IF obry% = 4 THEN VSSprite VARSEG(box2%(0)), VARPTR(box2%(0)), 85, 92 - y2%, VARSEG(buffer%(0)), VARPTR(buffer%(0))
      FOR obrx% = 1 TO 8
         temp% = obrx% + 11 * obry%
         VSTextureT VARSEG(box%(0)), VARPTR(box%(0)), pt2d(temp%).x, pt2d(temp%).y, pt2d(temp% + 1).x, pt2d(temp% + 1).y, pt2d(temp% + 12).x, pt2d(temp% + 12).y, pt2d(temp% + 11).x, pt2d(temp% + 11).y, VARSEG(buffer%(0)), VARPTR(buffer%(0))
      NEXT
   NEXT
   'VSFont VARSEG(buffer%(0)), VARPTR(buffer%(0)), 0, 1, STR$(t2%) + " fps", 31, 16
   VSPCopy VARSEG(buffer%(0)), VARPTR(buffer%(0)), &HA000, 0

END SUB

REM $STATIC
SUB initobject
radius = 85
object(60, 3).y = 1

FOR obr = 1 TO 9
   FOR obr2 = 1 TO 9
      object(obr2 * 11 + obr, 0).z = (obr2 - 5) * radius \ 2
      object(obr2 * 11 + obr, 0).x = (obr - 5) * radius \ 2
   NEXT
NEXT
FOR obr = 12 TO 108
   object(obr, 0).y = 0
NEXT
max = radius \ 2
END SUB

SUB ripple

FOR obr = 12 TO 108
   object(obr, 2).y = object(obr, 1).y
   object(obr, 1).y = object(obr, 0).y
NEXT
   temp% = object(60, 2).y * 3 \ 4
   object(61, 0).y = temp%
   object(59, 0).y = temp%
   object(71, 0).y = temp%
   object(49, 0).y = temp%

   object(48, 0).y = object(49, 2).y * 3 \ 4
   object(50, 0).y = object(49, 2).y * 3 \ 4
   object(70, 0).y = object(71, 2).y * 3 \ 4
   object(72, 0).y = object(71, 2).y * 3 \ 4

FOR obr = 0 TO 2
   object(15 + obr, 0).y = object(obr + 26, 2).y * 3 \ 4
   object(26 + obr, 0).y = object(obr + 37, 2).y * 3 \ 4
   object(37 + obr, 0).y = object(obr + 48, 2).y * 3 \ 4
                          
   object(81 + obr, 0).y = object(obr + 70, 2).y * 3 \ 4
   object(92 + obr, 0).y = object(obr + 81, 2).y * 3 \ 4
   object(103 + obr, 0).y = object(obr + 92, 2).y * 3 \ 4
NEXT

FOR obr = 1 TO 9
   object(3 + obr * 11, 0).y = object(4 + obr * 11, 2).y * 3 \ 4
   object(2 + obr * 11, 0).y = object(3 + obr * 11, 2).y * 3 \ 4
   object(1 + obr * 11, 0).y = object(2 + obr * 11, 0).y * 3 \ 4

   object(7 + obr * 11, 0).y = object(6 + obr * 11, 2).y * 3 \ 4
   object(8 + obr * 11, 0).y = object(7 + obr * 11, 2).y * 3 \ 4
   object(9 + obr * 11, 0).y = object(8 + obr * 11, 2).y * 3 \ 4
NEXT
  
  
   object(60, 0).y = object(60, 0).y + object(60, 3).y * radius \ choppy%
   IF object(60, 0).y >= max THEN
      max = radius \ -2
      object(60, 3).y = -1
   ELSEIF object(60, 0).y <= -max THEN
      max = -radius \ -2
      object(60, 3).y = 1
   END IF
  
   FOR obr = 12 TO 108
      coordbuffer(obr).y = (119 * object(obr, 0).y - 44 * object(obr, 0).z) \ 128
      coordbuffer(obr).z = (44 * object(obr, 0).y + 119 * object(obr, 0).z) \ 128
   NEXT

END SUB

SUB vsintro
PRINT
PRINT "VSRipple v2.0..."
PRINT "By 1998 VirtuaSoft"
PRINT "Programmed by Danny Gump with the DashX graphics library."
PRINT "E-mail: gump@gnt.net"
PRINT "URL: http://www.gnt.net/~gump"
SLEEP
SCREEN 13
VSPalette ""
FOR a% = 0 TO 29
   LINE (a%, 59)-(a% + 30, 0), 31
NEXT
GET (0, 0)-(59, 59), box3%
DEF SEG = VARSEG(box%(0)): BLOAD "water.txr", VARPTR(box%(0))
DEF SEG = VARSEG(box2%(0)): BLOAD "vssmall.pic", VARPTR(box2%(0))
VSFill &HA000, 0, 0
VSPalette "rpg"
initobject
t = TIMER
choppy% = 4
sec% = 0
fps% = 15
DO UNTIL INP(&H60) = 1 OR (y2% > 20 AND coordbuffer(49).y > 1)
   ripple
   IF sec% = 0 THEN
      drawobject
   ELSE
      IF t3% < fps% THEN
         IF t1% MOD (fps% \ (fps% - t3%)) <> 0 THEN drawobject
      ELSE
         drawobject
         IF t1% MOD (fps% \ (fps% - t3%)) = 0 THEN drawobject
      END IF
   END IF
   temp% = box%(2)
   VSBlit VARSEG(box%(0)), VARPTR(box%(3)), VARSEG(box%(0)), VARPTR(box%(2)), 1600
   box%(801) = temp%
   t1% = t1% + 1
   IF t + 1 < TIMER THEN
      t2% = t1%
      t1% = 0
      t = TIMER
      y2% = y2% + 2
      choppy% = choppy% + 1
      sec% = sec% + 1
      IF sec% = 1 THEN t3% = t2%
   END IF
LOOP
DEF SEG = VARSEG(box2%(0))
BLOAD "vs.pic", VARPTR(box2%(0))
VSBlendPalettes "rpg", "gold"
FOR a% = 32 TO 64
   VSFill VARSEG(buffer%(0)), VARPTR(buffer%(0)), 0
   VSSpriteS VARSEG(box2%(0)), VARPTR(box2%(0)), 160, 85, a%, a%, VARSEG(buffer%(0)), VARPTR(buffer%(0))
   VSPCopy VARSEG(buffer%(0)), VARPTR(buffer%(0)), &HA000, 0
NEXT
VSPut32 VARSEG(box2%(0)), VARPTR(box2%(0)), 10, 55, &HA000, 0
vsdelay 60
VSFadeBlack 63
END SUB

